package projektsystemKerne;
import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
  * Klassen til hndtering af Aktivitet-Objekter i relationel database  
  * @version  Januar 2002 (1.10)
  * @author   DBObjectAdministratorGenerator  
*/  

public class AktivitetAdministrator  extends DBObjectAdministrator  
{  
  private  int  lastKey   = 0;     // gemmer til autonummerering 
  public  AktivitetAdministrator (DBAdministrator    dbAdministrator,   
                              String table)  
  {  
    super (dbAdministrator, table, "ID","SELECT * FROM "+table);  
    lastKey = getLastKey();    // gemmer til autonummerering  
  }  

  // get-metode med to ngler disables, da objekt er med enkeltngle
  public  Object  get (int key, int key2)
  {
    System.out.println("Fejl: der skal anvendes metode med eet nglerfelt");
    throw new UnsupportedOperationException();
  }

  // contains-metode som checkker om objekt med ngle findes
  public  boolean  contains ( Object object )  
  {  
    Aktivitet   aktivitet = (Aktivitet)object;  
    return get(aktivitet.getID()) != null;
  }

  // opretter et nyt object p databasen - implementer abstract  
  public  boolean  add ( Object object )
  {  
    Aktivitet   aktivitet = (Aktivitet)object;  
     
    String  SQL_TildeltDato;
    if (aktivitet.getTildeltDato() == null) SQL_TildeltDato = "NULL";
    else SQL_TildeltDato = "'"+aktivitet.getTildeltDato().toString().substring(0,19)+"'";
    String  SQL_FaerdigDato;
    if (aktivitet.getFaerdigDato() == null) SQL_FaerdigDato = "NULL";
    else SQL_FaerdigDato = "'"+aktivitet.getFaerdigDato().toString().substring(0,19)+"'";
     
    String sql   = "INSERT INTO "+table  
                + " ("  
                + "  [ID]"  
                + "  ,[Betegnelse]"  
                + "  ,[TildeltDato]"  
                + "  ,[FaerdigDato]"  
                + "  ,[Tilstand]"  
                + "  ,[MedarbejderID]"  
                + "  ,[ProjektID]"  
                + " ) VALUES "  
                + " ("  
                + "  "  +aktivitet.getID()      +""  
                + ", '"  +aktivitet.getBetegnelse()      +"'"  
                + ", "  +SQL_TildeltDato
                + ", "  +SQL_FaerdigDato
                + ", "  +aktivitet.getTilstand()      +""  
                + ", "  +aktivitet.getMedarbejderID()      +""  
                + ", "  +aktivitet.getProjektID()      +""  
                + " )";  
    return ( executeUpdate (sql) );  
  }  


  // opdaterer et eksisterede object p databasen - implementer abstract  
  public  boolean  replace ( Object object )  
  {  
    Aktivitet   aktivitet = (Aktivitet)object;  
     
    String  SQL_TildeltDato;
    if (aktivitet.getTildeltDato() == null) SQL_TildeltDato = "NULL";
    else SQL_TildeltDato = "'"+aktivitet.getTildeltDato().toString().substring(0,19)+"'";
    String  SQL_FaerdigDato;
    if (aktivitet.getFaerdigDato() == null) SQL_FaerdigDato = "NULL";
    else SQL_FaerdigDato = "'"+aktivitet.getFaerdigDato().toString().substring(0,19)+"'";
     
    String sql  = "UPDATE "+table+" SET"  
                + "  [Betegnelse]='"  +aktivitet.getBetegnelse()    +"'"  
                + ", [TildeltDato]="  +SQL_TildeltDato
                + ", [FaerdigDato]="  +SQL_FaerdigDato
                + ", [Tilstand]="  +aktivitet.getTilstand()    +""  
                + ", [MedarbejderID]="  +aktivitet.getMedarbejderID()    +""  
                + ", [ProjektID]="  +aktivitet.getProjektID()    +""  
                + " WHERE [ID]="  +aktivitet.getID()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // sletter et object fra dabasen - implementer abstract  
  public  boolean  remove ( Object object )  
  {  
    Aktivitet   aktivitet = (Aktivitet)object;  
    String sql  = "DELETE * FROM "+table  
                + " WHERE [ID]="  +aktivitet.getID()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // Konverter fra ResultSet til object - implementer abstract  
  protected  Object  convertToObject (ResultSet resultSet)  
  {  
    try  
    {  
      Aktivitet   aktivitet = new Aktivitet (   resultSet.getInt("ID"),  
                                   resultSet.getString("Betegnelse"),  
                                   resultSet.getTimestamp("TildeltDato"),  
                                   resultSet.getTimestamp("FaerdigDato"),  
                                   resultSet.getInt("Tilstand"),  
                                   resultSet.getInt("MedarbejderID"),  
                                   resultSet.getInt("ProjektID")   ); 
      return (aktivitet);  
    }  
    catch (SQLException e)      
    {  
      System.out.println("Fejl ved convertToObject fra "+table);
      return (null);  
    }  
  }  


  // Ekstra metoder

  // returner et nyt object - skal gemmes p databasen med add  
  // metoden er tilrettet 
  public  Aktivitet  newAktivitet (  String betegnelse, 
                                     Timestamp tildeltDato, 
                                     Medarbejder medarbejder, 
                                     Projekt projekt )
  {  
    ++lastKey;  
    Aktivitet aktivitet = new Aktivitet ( lastKey,
                                          betegnelse, 
                                          tildeltDato, 
                                          medarbejder, 
                                          projekt );
    return (aktivitet);  
  }  

  // returner aggregerede aktiviteter til projekt
  public Iterator iterator (Projekt projekt)
  {
    return iterator ("WHERE [ProjektID] = "+projekt.getID());
  }

  // returner associerede aktiviteter til medarbejder
  public Iterator iterator (Medarbejder medarbejder)
  {
    return iterator ("WHERE [MedarbejderID] = "+medarbejder.getID());
  }


}  