package projektsystemKerne;
import java.util.*;  
import java.sql.*;  
/**  
  * @version  Januar 2002 (1.10)
  * @author   ObjectGenerator  
  * tilrettet af Bjrk Busch februar 2003 / januar 2004
*/  

public class Medarbejder
{  
  public  static  int      TILSTAND_ANSAT = 0;
  public  static  int      TILSTAND_AFGAAET = 1;
  public  static  int      AFGAAET_AARSAG_FYRET = 0;
  public  static  int      AFGAAET_AARSAG_SAGTOP = 1;

  private   int            iD;
  private   String         fornavn;
  private   String         efternavn;
  private   String         gade;
  private   String         tlf;
  private   Timestamp      ansatDato;
  private   Timestamp      afgaaetDato;
  private   int            afgaaetAarsag;
  private   int            tilstand;
  private   int            postnr;


  // Constructor til at genetablere eksisterende object
  public   Medarbejder ( int            iD,
                         String         fornavn,
                         String         efternavn,
                         String         gade,
                         String         tlf,
                         Timestamp      ansatDato,
                         Timestamp      afgaaetDato,
                         int            afgaaetAarsag,
                         int            tilstand,
                         int            postnr )
  {
    this.iD = iD;
    this.fornavn = fornavn;
    this.efternavn = efternavn;
    this.gade = gade;
    this.tlf = tlf;
    if (ansatDato == null) this.ansatDato = null;
    else this.ansatDato = (Timestamp)ansatDato.clone();
    if (afgaaetDato == null) this.afgaaetDato = null;
    else this.afgaaetDato = (Timestamp)afgaaetDato.clone();
    this.afgaaetAarsag = afgaaetAarsag;
    this.tilstand = tilstand;
    this.postnr = postnr;
  }

  //------- getmetoder
  protected   int   getID ( )
  {  return this.iD;   }
  public   String   getFornavn ( )
  {  return this.fornavn;   }
  public   String   getEfternavn ( )
  {  return this.efternavn;   }
  public   String   getGade ( )
  {  return this.gade;   }
  public   String   getTlf ( )
  {  return this.tlf;   }
  public   Timestamp   getAnsatDato ( )
  {
    if (this.ansatDato == null) return null;
    return (Timestamp)this.ansatDato.clone();
  }
  public   Timestamp   getAfgaaetDato ( )
  {
    if (this.afgaaetDato == null) return null;
    return (Timestamp)this.afgaaetDato.clone();
  }
  public   int   getAfgaaetAarsag ( )
  {  return this.afgaaetAarsag;   }
  public   int   getTilstand ( )
  {  return this.tilstand;   }
  protected   int   getPostnr ( )         // rettet til protected
  {  return this.postnr;   }

  public    String   toString()
  {
    return (""+ getFornavn ( )
            + ","+ getEfternavn ( )
            + ","+ getGade ( )
            + ","+ getTlf ( )
            + ","+ getAnsatDato ( )
            + ","+ getAfgaaetDato ( )
            + ","+ getAfgaaetAarsag ( )
            + ","+ getTilstand ( )
            );
  }


  //------- ekstra metoder
  // Tilgang til Medarbejder-collection controler
  private  static  MedarbejderAdministrator  getMedarbejderAdministrator()
  {    return (PersistensAdministrator.getMedarbejderAdministrator());  }

  // Tilgang til Aktivitet-collection controler
  private  static  AktivitetAdministrator  getAktivitetAdministrator()
  {    return (PersistensAdministrator.getAktivitetAdministrator());  }

  // Tilgang til Postdistrikt-collection controler
  private  static  PostdistriktAdministrator  getPostdistriktAdministrator()
  {  return (PersistensAdministrator.getPostdistriktAdministrator());  }

  // Constructor til at oprette object
  public   Medarbejder ( int            iD,
                         String         fornavn,
                         String         efternavn,
                         String         gade,
                         String         tlf,
                         Timestamp      ansatDato,
                         Postdistrikt   postdistrikt )
  {
    this.fornavn = fornavn;
    this.efternavn = efternavn;
    this.gade = gade;
    this.tlf = tlf;
    this.ansatDato   = (Timestamp)ansatDato.clone();
    this.tilstand = TILSTAND_ANSAT;
    if (postdistrikt == null)  this.postnr = 0;
    else this.postnr = postdistrikt.getPostnr();
  }


  public   void   retStamdata ( String fornavn, String efternavn,
                                String gade, String tlf,
                                Postdistrikt   postdistrikt)
  {
    this.fornavn = fornavn;
    this.efternavn = efternavn;
    this.gade = gade;
    this.tlf = tlf;
    MedarbejderAdministrator medarbejderAdm = getMedarbejderAdministrator();
    medarbejderAdm.replace(this);
  }

  public   Iterator   getAktivitetIterator ()
  { 
    AktivitetAdministrator aktivitetAdm = getAktivitetAdministrator();
    return aktivitetAdm.iterator(this);
  }

  public   Postdistrikt   getPostdistrikt ( )
  {  
    PostdistriktAdministrator postdistriktAdm = getPostdistriktAdministrator();
    return (Postdistrikt)postdistriktAdm.get(postnr);
  }

  // registrering af medarbejder afget
  public   void   afgaaet (Timestamp dato, int aarsag)
  {  
    this.afgaaetDato   = (Timestamp)dato.clone();
    this.afgaaetAarsag = aarsag;
    this.tilstand      = TILSTAND_AFGAAET;
    MedarbejderAdministrator medarbejderAdm = getMedarbejderAdministrator();
    medarbejderAdm.replace(this);
  }


}  
