package projektsystemKerne;
import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
  * Klassen til hndtering af Medarbejder-Objekter i relationel database  
  * @version  Januar 2002 (1.10)
  * @author   DBObjectAdministratorGenerator  
*/  

public class MedarbejderAdministrator  extends DBObjectAdministrator  
{  
  private  int  lastKey   = 0;     // gemmer til autonummerering 
  public  MedarbejderAdministrator (DBAdministrator    dbAdministrator,   
                              String table)  
  {  
    super (dbAdministrator, table, "ID","SELECT * FROM "+table);  
    lastKey = getLastKey();    // gemmer til autonummerering  
  }  

  // get-metode med to ngler disables, da objekt er med enkeltngle
  public  Object  get (int key, int key2)
  {
    System.out.println("Fejl: der skal anvendes metode med eet nglerfelt");
    throw new UnsupportedOperationException();
  }

  // contains-metode som checkker om objekt med ngle findes
  public  boolean  contains ( Object object )  
  {  
    Medarbejder   medarbejder = (Medarbejder)object;  
    return get(medarbejder.getID()) != null;
  }

  // opretter et nyt object p databasen - implementer abstract  
  public  boolean  add ( Object object )
  {  
    Medarbejder   medarbejder = (Medarbejder)object;  
     
    String  SQL_AnsatDato;
    if (medarbejder.getAnsatDato() == null) SQL_AnsatDato = "NULL";
    else SQL_AnsatDato = "'"+medarbejder.getAnsatDato().toString().substring(0,19)+"'";
    String  SQL_AfgaaetDato;
    if (medarbejder.getAfgaaetDato() == null) SQL_AfgaaetDato = "NULL";
    else SQL_AfgaaetDato = "'"+medarbejder.getAfgaaetDato().toString().substring(0,19)+"'";
     
    String sql   = "INSERT INTO "+table  
                + " ("  
                + "  [ID]"  
                + "  ,[Fornavn]"  
                + "  ,[Efternavn]"  
                + "  ,[Gade]"  
                + "  ,[Tlf]"  
                + "  ,[AnsatDato]"  
                + "  ,[AfgaaetDato]"  
                + "  ,[AfgaaetAarsag]"  
                + "  ,[Tilstand]"  
                + "  ,[Postnr]"  
                + " ) VALUES "  
                + " ("  
                + "  "  +medarbejder.getID()      +""  
                + ", '"  +medarbejder.getFornavn()      +"'"  
                + ", '"  +medarbejder.getEfternavn()      +"'"  
                + ", '"  +medarbejder.getGade()      +"'"  
                + ", '"  +medarbejder.getTlf()      +"'"  
                + ", "  +SQL_AnsatDato
                + ", "  +SQL_AfgaaetDato
                + ", "  +medarbejder.getAfgaaetAarsag()      +""  
                + ", "  +medarbejder.getTilstand()      +""  
                + ", "  +medarbejder.getPostnr()      +""  
                + " )";  
    return ( executeUpdate (sql) );  
  }  

  // opdaterer et eksisterede object p databasen - implementer abstract  
  public  boolean  replace ( Object object )  
  {  
    Medarbejder   medarbejder = (Medarbejder)object;  
     
    String  SQL_AnsatDato;
    if (medarbejder.getAnsatDato() == null) SQL_AnsatDato = "NULL";
    else SQL_AnsatDato = "'"+medarbejder.getAnsatDato().toString().substring(0,19)+"'";
    String  SQL_AfgaaetDato;
    if (medarbejder.getAfgaaetDato() == null) SQL_AfgaaetDato = "NULL";
    else SQL_AfgaaetDato = "'"+medarbejder.getAfgaaetDato().toString().substring(0,19)+"'";
     
    String sql  = "UPDATE "+table+" SET"  
                + "  [Fornavn]='"  +medarbejder.getFornavn()    +"'"  
                + ", [Efternavn]='"  +medarbejder.getEfternavn()    +"'"  
                + ", [Gade]='"  +medarbejder.getGade()    +"'"  
                + ", [Tlf]='"  +medarbejder.getTlf()    +"'"  
                + ", [AnsatDato]="  +SQL_AnsatDato
                + ", [AfgaaetDato]="  +SQL_AfgaaetDato
                + ", [AfgaaetAarsag]="  +medarbejder.getAfgaaetAarsag()    +""  
                + ", [Tilstand]="  +medarbejder.getTilstand()    +""  
                + ", [Postnr]="  +medarbejder.getPostnr()    +""  
                + " WHERE [ID]="  +medarbejder.getID()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // sletter et object fra dabasen - implementer abstract  
  public  boolean  remove ( Object object )  
  {  
    Medarbejder   medarbejder = (Medarbejder)object;  
    String sql  = "DELETE * FROM "+table  
                + " WHERE [ID]="  +medarbejder.getID()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // Konverter fra ResultSet til object - implementer abstract  
  protected  Object  convertToObject (ResultSet resultSet)  
  {  
    try  
    {  
      Medarbejder   medarbejder = new Medarbejder (   resultSet.getInt("ID"),  
                                   resultSet.getString("Fornavn"),  
                                   resultSet.getString("Efternavn"),  
                                   resultSet.getString("Gade"),  
                                   resultSet.getString("Tlf"),  
                                   resultSet.getTimestamp("AnsatDato"),  
                                   resultSet.getTimestamp("AfgaaetDato"),  
                                   resultSet.getInt("AfgaaetAarsag"),  
                                   resultSet.getInt("Tilstand"),  
                                   resultSet.getInt("Postnr")   ); 
      return (medarbejder);  
    }  
    catch (SQLException e)      
    {  
      System.out.println("Fejl ved convertToObject fra "+table);
      return (null);  
    }  
  }  

  // Ekstra metoder

  // returner et nyt object - skal gemmes p databasen med add  
  // metoden er tilrettet 
  public  Medarbejder  newMedarbejder (
                                     String fornavn, 
                                     String efternavn, 
                                     String gade, 
                                     String tlf, 
                                     Timestamp ansatDato, 
                                     Postdistrikt postdistrikt )
  {  
    ++lastKey;  
    Medarbejder medarbejder = new Medarbejder ( lastKey,
                               fornavn, 
                               efternavn, 
                               gade, 
                               tlf, 
                               ansatDato, 
                               postdistrikt );
    return (medarbejder);  
  }  

}  